# require 'rails_helper'

# RSpec.describe ComplexSubject do
#   before do
#     class ExampleWork < ActiveFedora::Base
#       property :complex_subject, predicate: ::RDF::Vocab::DC.subject,
#                class_name:"ComplexSubject"
#       accepts_nested_attributes_for :complex_subject
#     end
#   end
#   after do
#     Object.send(:remove_const, :ExampleWork)
#   end

#   context 'uri with a #' do
#     before do
#       # special hack to force code path for testing
#       allow_any_instance_of(RDF::Node).to receive(:node?) { false }
#       allow_any_instance_of(RDF::Node).to receive(:start_with?) { true }
#     end
#     subject do
#       ExampleWork
#         .new({ complex_subject_attributes: [{subject_identifier: '12345'}]})
#         .complex_subject
#         .first
#         .subject_identifier
#     end
#     it { is_expected.to eq ['12345'] }
#   end

#   it 'has the correct uri' do
#     @obj = ExampleWork.new
#     @obj.attributes = {
#       complex_subject_attributes: [
#         {
#           subject_identifier: '12345'
#         }
#       ]
#     }
#     expect(@obj.complex_subject.first.id).to include('#subject')
#   end

#   it 'creates a subject active triple resource with all the attributes' do
#     @obj = ExampleWork.new
#     @obj.attributes = {
#       complex_subject_attributes: [
#         {
#           subject_identifier: '12456',
#           subject_species: 'species'
#         }
#       ]
#     }
#     expect(@obj.complex_subject.first).to be_kind_of ActiveTriples::Resource
#     expect(@obj.complex_subject.first.subject_identifier).to eq ['12456']
#     expect(@obj.complex_subject.first.subject_species).to eq ['species']

#   end

#   describe 'when reject_if is a symbol' do
#     before do
#       class ExampleWork2 < ExampleWork
#         include ComplexValidation
#         accepts_nested_attributes_for :complex_subject, reject_if: :subject_blank
#       end
#     end
#     after do
#       Object.send(:remove_const, :ExampleWork2)
#     end

#     it 'creates a subject active triple resource when any value is filled' do
#       @obj = ExampleWork2.new
#       @obj.attributes = {
#         complex_subject_attributes: [
#           {
#             subject_identifier: '12456'
#           }
#         ]
#       }
#       expect(@obj.complex_subject.first).to be_kind_of ActiveTriples::Resource
#       expect(@obj.complex_subject.first.subject_identifier).to eq ['12456']
#       expect(@obj.complex_subject.first.subject_species).to be_empty
#     end

#     it 'rejects a subject active triple with no values' do
#       @obj = ExampleWork2.new
#       @obj.attributes = {
#         complex_subject_attributes: [
#           {
#             subject_identifier: ''
#           }
#         ]
#       }
#       expect(@obj.complex_subject).to be_empty
#     end
#   end

# end
